rmconfig='no'
case $CONFIG in
'')
	if test ! -f config.sh; then
		ln ../config.sh . || \
			ln ../../config.sh . || \
			ln ../../../config.sh . || \
			(echo "Can't find config.sh."; exit 1)
		rmconfig='yes'
	fi
	. config.sh
	;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting kdb-high/Makefile (with variable substitutions)"
: Some headers, do no variable substitution
$spitshell >Makefile <<'!NO!SUBS!'
#
# Makefile fuer KEF kdb-high
#
# sccsid = @(#)  Makefile  (v2.3 5/2/90)
#

#
# Some general stuff
#
SHELL	=	/bin/sh
SCCSPATH=
!NO!SUBS!
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.  You may delete these comments.
$spitshell >>Makefile <<!GROK!THIS!

#
# The values of the following variables come from config.sh which has
# been generated by running the Configure script.
#
CC=$cc
STDCFLAGS=$ccflags
LDFLAGS=$ldflags
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>Makefile <<'!NO!SUBS!'

# Debug flags go into DEB. Delete the object and recompile.
# Debug info is written to "FILE * prot"
# Define them as "-DDEBUG_ADD".
#
#     flag          |  file
#   ----------------+------------------
#   DEBUG_ADD       |  add.c
#   DEBUG_CLEANUP   |  cleanup.c
#   DEBUG_INIT      |  create_db.c mcreate_db.c
#   DEBUG_MISC      |  misc.c
#   DEBUG_IO        |  read.c mread.c
#   DEBUG_STR       |  str.c
DEB		=

#
# INCL should be pointing at the directory kef.h etc. are in.
#
INCL	=	-I..

#
# Compile flags
#
CFLAGS	=	${DEB} ${INCL}

#
# Object files
#
OBJS	=	add.o cleanup.o create_db.o mcreate_db.o mread.o read.o str.o \
			misc.o

KEF_LIB	=	../libkef.a

#
# Dependencies
# ============
#

all: ${KEF_LIB}

${KEF_LIB}: ${OBJS}
	ar rv ${KEF_LIB} $?
	ranlib ${KEF_LIB}

${OBJS}: ../kef.h
!NO!SUBS!
chmod 755 Makefile
$eunicefix Makefile
if test "$rmconfig" = "yes" ; then
	rm -f config.sh
fi
