static char * sccsid = "@(#)  add.c  (v1.8 4/26/90)";

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_ADD
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

# ifdef L_DEBUG
extern char * kef_error ();
# endif

	int
kef_add (kdb, s, val)
	struct kef_db * kdb;
	char * s;
	kef_value val;
/*
 * If there are no more free nodes in nodes array, it is extended
 * using my_realloc. This works only if the array has been allocated
 * previously by malloc.
 */
{
	DI("kef_add ::")
	register int i, count, redo;
	struct kef_node * tmp;

	/*
	 * As long as we try and get an error we extend the structure
	 * and retry.
	 */
	for (count = 1, redo = 1; count < 10 && redo == 1; count++) {
		DEB3("%s try to add '%s' for the %1d. time\n", s, count);
		FLUSH;
		i = kef__add (kdb, s, val);
# ifdef L_DEBUG
		if (i < 0)
			fprintf (prot, "kef_add ERROR : %s\n", kef_error (i));
# endif

		if (i != KEF_E_NODES_USEDUP)
			return i;
		/*
		 * Extend the nodes array
		 */
		if (kdb->realloc == NULL)
			return KEF_E_NO_REALLOC;
		tmp = (struct kef_node *) (* kdb->realloc) ((char *)kdb->node,
			(unsigned int)(kdb->num_nodes + 32 * count) *
			sizeof (struct kef_node));
		if (tmp == NULL)
			return KEF_E_ALLOC_FAILED;
		kdb->num_nodes += 32*count;
		kdb->node = tmp;
	}
	return count < 10 ? KEF_E_OK : i;
}
