static char * sccsid = "@(#)  mcreate_db.c  (v1.6 4/17/90)";

/*
 * Create (allocate) and initialize a kef_db structure.
 */

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_INIT
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

# define DEF_NUM_NODES	128

extern int kef__init_db ();

	int
kef_mcreate_db (pkdb, num_nodes, my_malloc, my_realloc, my_free)
	struct kef_db ** pkdb;
	int num_nodes;
	char * (* my_malloc) ();
	char * (* my_realloc) ();
	FREE_TYPE (* my_free) ();
{
	register int i;
	struct kef_node * nd;

	if (my_malloc == NULL)
		return KEF_E_NO_MALLOC;
	/*
	 * Allocate a kef_db structure. A structure consists of 2 parts:
	 * a header, the node array. These are allocated in turn.
	 */
	*pkdb = (struct kef_db *) (* my_malloc) (sizeof (struct kef_db));
	if (num_nodes <= 0)
		num_nodes = DEF_NUM_NODES;
	nd  = (struct kef_node *) (* my_malloc) (sizeof (struct kef_node) * num_nodes);
	if (*pkdb == NULL || nd == NULL)
		return KEF_E_ALLOC_FAILED;

	/*
	 * Set the entries in it to default values.
	 */
	i = kef__init_db (*pkdb, nd, num_nodes, my_malloc, my_realloc, my_free);

	(*pkdb)->was_allocated = 1;

	return i;
}
