static char * sccsid = "@(#)  mread.c  (v1.7 3/21/90)";

/*
 * Read a structure from a file.
 */

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_IO
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

	int
kef_mread (fd, pkdb, my_malloc, my_realloc, my_free)
	register int fd;
	struct kef_db ** pkdb;
	char * (* my_malloc)();
	char * (* my_realloc)();
	FREE_TYPE (* my_free)();
/*
 * Create a structure and read into it from a file.
 */
{
	DI("kef_mread ::")
	register int n;
	struct kef_fheader kfh;
	struct kef_node * nd;

	if ((long)my_malloc == 0L)
		return KEF_E_NO_MALLOC;
	if ((long)my_free == 0L)
		return KEF_E_NO_FREE;

	n = kef_read_header (fd, &kfh);
	if (n != KEF_E_OK)
		return n;

	DEB1("%s got header from file\n");

	/*
	 * Allocate kef_db structure and nodes array.
	 */
	*pkdb = (struct kef_db *) (* my_malloc) (sizeof (struct kef_db));
	if (*pkdb == NULL)
		return KEF_E_ALLOC_FAILED;

	n = sizeof (struct kef_node) * kfh.num_nodes;
	nd = (struct kef_node *) (* my_malloc) (n);
	if (nd == NULL)
		return KEF_E_ALLOC_FAILED;
	/*
	 * Read stuff.
	 */
	n = kef_read_file (fd, *pkdb, kfh.size_kdb, nd, kfh.num_nodes,
		kfh.swap != 0x0201);
	if (n != KEF_E_OK) {
		(void) (* my_free) ((*pkdb)->node);
		(void) (* my_free) ((*pkdb));
	} else {
		/*
		 * Set kdb for the current configuration.
		 */
		(*pkdb)->node = nd;
		(*pkdb)->num_nodes = kfh.num_nodes;
		(*pkdb)->was_allocated = 1;
		(*pkdb)->malloc = my_malloc;
		(*pkdb)->realloc = my_realloc;
		(*pkdb)->free = my_free;
	}
	return n;
}
